# mcio_ctrl

### [MCio mod](https://github.com/twoturtles/MCio) | [mcio_ctrl](https://github.com/twoturtles/mcio_ctrl) | [Documentation](https://github.com/twoturtles/mcio_ctrl/wiki) | [Discord](https://discord.gg/vaFEBynG)

`mcio_ctrl` is a comprehensive Python library designed to interface seamlessly with [MCio](https://github.com/twoturtles/MCio), a Minecraft Fabric mod tailored for AI agent development. It includes a versatile [Gymnasium](https://gymnasium.farama.org/) environment, making it ideal for reinforcement learning research and development.

## Key Features

* **Simplified Installation and Launching:** API and commands to easily install Minecraft with the MCio mod, create custom worlds, and launch the game directly from Python.
* **Pre-built Gymnasium Environments:** Offers example environments, including compatibility with MineRL 1.0 actions and observations, all leveraging the robust low-level API.
* **Customizable Base Environment:** A convenient base class for quickly creating tailored Gymnasium environments suited to specific research needs.
* **Interactive GUI Support:** Enables human control of Minecraft through the standard Minecraft controls using the MCio backend. (Seamless Human-in-the-loop is planned for future updates.)
* **Type-Hinting and Development Convenience:** Fully type-hinted for easier integration, improved code clarity, and streamlined development workflows.

## Quick Links

* **Documentation:** Find comprehensive documentation and tutorials on our [Wiki](https://github.com/twoturtles/mcio_ctrl/wiki).

* **MCio Mod:**
  * [GitHub Repository](https://github.com/twoturtles/MCio)
  * [Modrinth Project Page](https://modrinth.com/mod/mcio)

* **Python Interface (`mcio_ctrl`):**
  * [GitHub Repository](https://github.com/twoturtles/mcio_ctrl)
  * [PyPI Package](https://pypi.org/project/mcio_ctrl/)
